// Code generated by gopkg.in/reform.v1. DO NOT EDIT.

package db

import (
	"fmt"
	"strings"

	"gopkg.in/reform.v1"
	"gopkg.in/reform.v1/parse"
)

type walletViewType struct {
	s parse.StructInfo
	z []interface{}
}

// Schema returns a schema name in SQL database ("").
func (v *walletViewType) Schema() string {
	return v.s.SQLSchema
}

// Name returns a view or table name in SQL database ("wallet").
func (v *walletViewType) Name() string {
	return v.s.SQLName
}

// Columns returns a new slice of column names for that view or table in SQL database.
func (v *walletViewType) Columns() []string {
	return []string{"id", "user_id", "currency", "status", "balance", "locked", "created", "updated"}
}

// NewStruct makes a new struct for that view or table.
func (v *walletViewType) NewStruct() reform.Struct {
	return new(Wallet)
}

// WalletView represents wallet view or table in SQL database.
var WalletView = &walletViewType{
	s: parse.StructInfo{Type: "Wallet", SQLSchema: "", SQLName: "wallet", Fields: []parse.FieldInfo{{Name: "Id", Type: "int64", Column: "id"}, {Name: "UserId", Type: "int64", Column: "user_id"}, {Name: "Currency", Type: "protobufMain.Currency", Column: "currency"}, {Name: "Status", Type: "protobufWallet.WalletStatus", Column: "status"}, {Name: "Balance", Type: "float64", Column: "balance"}, {Name: "Locked", Type: "*time.Time", Column: "locked"}, {Name: "Created", Type: "time.Time", Column: "created"}, {Name: "Updated", Type: "time.Time", Column: "updated"}}, PKFieldIndex: -1},
	z: new(Wallet).Values(),
}

// String returns a string representation of this struct or record.
func (s Wallet) String() string {
	res := make([]string, 8)
	res[0] = "Id: " + reform.Inspect(s.Id, true)
	res[1] = "UserId: " + reform.Inspect(s.UserId, true)
	res[2] = "Currency: " + reform.Inspect(s.Currency, true)
	res[3] = "Status: " + reform.Inspect(s.Status, true)
	res[4] = "Balance: " + reform.Inspect(s.Balance, true)
	res[5] = "Locked: " + reform.Inspect(s.Locked, true)
	res[6] = "Created: " + reform.Inspect(s.Created, true)
	res[7] = "Updated: " + reform.Inspect(s.Updated, true)
	return strings.Join(res, ", ")
}

// Values returns a slice of struct or record field values.
// Returned interface{} values are never untyped nils.
func (s *Wallet) Values() []interface{} {
	return []interface{}{
		s.Id,
		s.UserId,
		s.Currency,
		s.Status,
		s.Balance,
		s.Locked,
		s.Created,
		s.Updated,
	}
}

// Pointers returns a slice of pointers to struct or record fields.
// Returned interface{} values are never untyped nils.
func (s *Wallet) Pointers() []interface{} {
	return []interface{}{
		&s.Id,
		&s.UserId,
		&s.Currency,
		&s.Status,
		&s.Balance,
		&s.Locked,
		&s.Created,
		&s.Updated,
	}
}

// View returns View object for that struct.
func (s *Wallet) View() reform.View {
	return WalletView
}

// check interfaces
var (
	_ reform.View   = WalletView
	_ reform.Struct = (*Wallet)(nil)
	_ fmt.Stringer  = (*Wallet)(nil)
)

func init() {
	parse.AssertUpToDate(&WalletView.s, new(Wallet))
}
